#!/usr/bin/env python

from serial import Serial
import sys

def console():
    try:
        while 1:
            s.write(raw_input("> ") + "\n")
            print s.readline().rstrip("\r\n")
    except EOFError:
        print "Session closed."

def upload(filename, sector):
    data = open(filename, "rb").read()

    if len(data) != 0x4000:
        print >>sys.stderr, "File", filename, "is not", 0x4000, "bytes long."
        return False

    print >>sys.stderr, "Erasing sector", sector, "..."

    s.write("S%x\n" % sector)
    resp = s.readline().rstrip("\r\n")
    if resp != "S":
        print >>sys.stderr, "Sector %d erase failed: %s" % (sector, resp)
        return False

    print >>sys.stderr, "Uploading", filename, "to sector", sector, "..."

    i = 0
    while i < 0x4000:
        value = ord(data[i])
        addr = (sector << 14) | i
        s.write("P%04x%02x\n" % (addr, value))
        print >>sys.stderr, "P%04x%02x" % (addr, value)
        resp = s.readline().rstrip("\r\n")
        if resp != "P":
            print >>sys.stderr, "Program of location %04x failed: %s" % (addr, resp)
            return False
        #s.write("R%04x\n" % addr)
        #print >>sys.stderr, "R%04x" % addr
        #readvalue = s.readline().rstrip("\r\n")
        #if readvalue != ("%X" % value):
        #    print >>sys.stderr, "Program of location %04x failed: %s read for %s written." % (addr, readvalue, "%X" % value)
        #    return False
        i += 1

    return True

if __name__ == "__main__":
    port = "/dev/ttyUSB0"
    rate = 115200

    s = Serial(port, rate)
    s.readline()

    if "-i" in sys.argv:
        console()
    elif len(sys.argv) > 1:
        for sector, filename in enumerate(sys.argv[1:]):
            upload(filename, sector)
    else:
        print >>sys.stderr, sys.argv[0], "-i | <filename>..."
        sys.exit(1)

# vim: tabstop=4 expandtab shiftwidth=4
